app.factory('Messages', function ($websocket, $sce, config) {
    //var ws = $websocket('wss://echo.websocket.org/');
    var ws = $websocket('ws://localhost:4202/');
    var collection = [];
    var gstatus = [];
    var gdataInfo = [];
    var gconfig = [];
    var settings = [];
    var sounds = [];



    ws.onMessage(function (event) {
        //console.log('message: ', event.data);
        var res;
        try {
            res = JSON.parse(event.data);
            
        } catch (e) {
            res = { 'MsgType': 'Msg', 'Entry': event.data };
            
        }
     if (res.MsgType === "ConfigResponse") {
            gconfig.push({
                wsConfig: res,
            });
     }
     if (res.MsgType === "GetFileListResponse") {
        // console.log(res.Files.length)
         var files = [];
         for (i = 0; i < res.Files.length; i++) {
             files += '{"id":"' + res.Files[i] + '", "name":"' + res.Files[i] + '"},';
         }
         files = files.replace(/,\s*$/, "");
         files = '[' + files + ']'
         files = JSON.parse(files)
         //console.log(files)
         res = files;
         sounds.push({
             wsSounds: res,
         });
     }


     if (res.MsgType === "GetIniResponse") {
         //console.log(res.settings)
         var string = "";
         var custom = "";
         var cstmConfigInt = "";
         var customSection = [];
         var testObj = [];
         for (i = 0; i < res.settings.length; i++) {
             if (res.settings[i].Section != "Debug" && res.settings[i].Section != "Windows" && res.settings[i].Section != "WebSocket") {
                 if (res.settings[i].Section.indexOf('DCIConfig') + 1) {
                     cstmConfigInt = res.settings[i].Section.substr(res.settings[i].Section.length - 1);
                     res.settings.cstmConfigInt = cstmConfigInt;
                     if (res.settings[i].Value.indexOf(':') - 1) {
                         //console.dir(res.settings[i])
                         customSection = res.settings[i].Section;
                         if (customSection == customSection) {
                            // customSection = [customSection]


                             testObj.push(res.settings[i]);
                                               
                         }
                     }
                 }
                 else {
                     if (res.settings[i].Value.indexOf(':') - 1) {
                         if (res.settings[i].Value.indexOf('{') + 1) {
                             string += '"' + res.settings[i].Key + '":' + res.settings[i].Value + ',';
                         }
                         else {
                             if (res.settings[i].Value == "*~*86e066687d2cc09fee7e502d5c762253") {
                                 string += '"' + res.settings[i].Key + '":"' + '",';
                             }else{
                                 string += '"' + res.settings[i].Key + '":"' + res.settings[i].Value + '",';
                             }
                         }
                     }
                   
                 }
             }
            
         }



         var arrTemp = [];

         var result = _.chain(testObj).groupBy("Section").map(function (v, i) {
             //console.log('VALUES');
             //console.dir(v);

             
             var oContainer = {};
             var oStuff = {}

             // Add key/value pairs to one obj
             angular.forEach(v, function (val, ind) {
                 if (val.Value.indexOf('{') + 1) {
                     val.Value = val.Value.replace(/\\/g, '');
                     val.Value = JSON.parse(val.Value)
                     oStuff[val.Key] = val.Value;
                 } else {
                     oStuff[val.Key] = val.Value;
                 }
             });
             oStuff.Section = i;
             // Add items to container obj
             oContainer[i] = oStuff;

             // Push container to array
             arrTemp.push(oStuff);
             

         }).value();


         var cstmArrLength = "";
         for (i = 0; i < arrTemp.length; i++) {
             //if(arrTemp[i].DCI.length > 0){
                 cstmArrLength = arrTemp[i].Section;
                 cstmArrLength = cstmArrLength.split("DCIConfig");
                 cstmArrLength = (parseInt(cstmArrLength[1]) + 1);
             //} 
         }

         //console.dir(arrTemp);

         var removeEmptyCustom = arrTemp;
         for (i = 0; i < removeEmptyCustom.length; i++) {
             if (removeEmptyCustom[i].DCI.length < 1) {
                 removeEmptyCustom.splice(i, 1)
                 
             }
         }
         //console.log(removeEmptyCustom)

         //var cstmArrLength = arrTemp.length;
         //console.log(cstmArrLength);
         //console.dir(testObj);
         //console.dir(result)
         custom = custom.replace(/,\s*$/, "");
         custom = '{' + custom + '}'
         custom = JSON.parse(custom)

         
         
         string = string.replace(/,\s*$/, "");
         string = '{' + string + '}'
         string = JSON.parse(string);
        
         gblCstm = removeEmptyCustom;

         res = string ;
         res.cstmArrLength = cstmArrLength;
         settings.push({
             wsSettings: res,             
             cstmSetting: removeEmptyCustom,
         });
     }
     else if (res.MsgType === "StatusResponse") {
         res.StatusResponse = res;
            gstatus.push({
                //wsStatus: res,
                wsData: res.StatusResponse,
            });
        }
     else if (res.MsgType === "ScanResponse") {
         if (res.Scan) {
             var customDCI = res.Scan.DCICustom;
             var validText = res.Scan.ValidText;
             var setconVal = res.Scan.Entry.toLowerCase();
             var setconDetail = res.Scan.Detail.toLowerCase();
             if (setconVal.startsWith("setcon")) {
                 if (setconVal === "setconundefined") {
                     //res.Scan.loginMessage = "Logged Out"
                 } else {
                     if(setconDetail.endsWith("disabled.")){
                         res.Scan.loginMessage = "Your Passcode is incorrect."
                     }
                 }

             }
             if (res.Scan.Detail.indexOf('INI replaced') != -1) {
                 res.Scan.NewGblIni = true;
             }
             if (res.Scan.DCICustom) {
                 //console.log("Custom DCI=" + res.Scan.DCICustom)
                 if (customDCI.length > 1) {
                     customDCI = customDCI.replace(/\\/g, '');
                     customDCI = JSON.parse(customDCI);
                     res.Scan.DCICustom = customDCI;
                 }
             } else {
 
                 var cleanDCI = [];
                 for (i = 0; i < gblCstm.length; i++) {
                     if (res.Pass){
                         if (res.Pass.DCI.indexOf(gblCstm[i].DCI) != -1) {
                             cleanDCI = ({
                                 DCI_bkgd_color: gblCstm[i].Custom.DCI_bkgd_color,
                                 DCI_font_color: gblCstm[i].Custom.DCI_font_color
                             });
                             res.Scan.DCICustom = cleanDCI;                         
                         }
                     }

                 }
                 
             }

             if (validText == "EXPIRED") {
                 res.Scan.scanValidDetail = "EXPIRED";
                 res.Scan.scanValidDetailImg = "calendar-times-regular.svg"
                 res.Scan.scanDetailMsg = res.Scan.Detail;
             }

             if (validText == "HOTLIST") {
                 res.Scan.scanValidDetail = "HOTLIST";
                 res.Scan.scanValidDetailImg = "hotjar-brands.svg"
                 res.Scan.scanDetailMsg = res.Scan.Detail;
             }

             //if (validText == "GOOD") {
             //    var scanGoodFor = res.Pass.GoodFor;
             //    var scanGoodNumber = "";
             //    if (scanGoodDetail.indexOf('Good') !== -1) {
             //        scanGoodDetail = scanGoodDetail.split(/\n/);
             //        scanGoodNumber = scanGoodDetail[1].split("Good for");
             //        //console.log(scanGoodNumber);
             //        res.Scan.scanDetailNumber = parseInt(scanGoodNumber[1].trim()) - 1;
             //        res.Scan.scanDetailMsg = scanGoodDetail[1];
             //    }
                 
             //}

             if (validText == "BAD") {
                 var scanDetail = res.Scan.Detail;
                 var scanDetailMsg = scanDetail.split(/\n/);
                 scanDetailMsg = scanDetailMsg[1].split("- PASS_NO");
                 //scanDetailMsg = scanDetailMsg[1].split("NEXT PASS");
                 var scanDetailMore = "PASS_NO" + scanDetailMsg[1];
                 scanDetailMsg = scanDetailMsg[0];
                 

                 var scanValidDetail = "BAD";
                 var scanValidDetailImg = "times-circle-regular.svg";
                 if(scanDetail.indexOf('after') !== -1){
                     scanValidDetail = "EXPIRED";
                     scanValidDetailImg = "calendar-times-regular.svg"
                 }
                 else if (scanDetail.indexOf('location') !== -1) {
                     scanValidDetail = "INVALID";
                     scanValidDetailImg = "hand-paper-regular.svg"
                 }
                 else if (scanDetail.indexOf('voided') !== -1) {
                     scanValidDetail = "VOIDED";
                     scanValidDetailImg = "expeditedssl-brands.svg"
                 }
                
                 else if (scanDetail.indexOf('total') !== -1) {
                     scanValidDetail = "USED";
                 }
                 
                 res.Scan.scanValidDetail = scanValidDetail;
                 res.Scan.scanValidDetailImg = scanValidDetailImg;
                 res.Scan.scanDetailMsg = scanDetailMsg;
                 res.Scan.scanDetailMore = scanDetailMore;
             }

         }
         if (res.Pass) {
                if(res.Pass.Email.length > 1){
                    var email = res.Pass.Email.trim().split("****").join("").split("- DCI");
                    email = email[0]
                    email = email.replace(/[\r\n]{4}/g, "<hr>");
                res.Pass.Email = email;                
                }
            }

         //MP: Set SessionStorage on each scan
        sessionStorage.setItem("lastScan", JSON.stringify(res))
        collection.push({
            wsData: res,
            //Entry: res.Entry,
        });
        } else if (res.MsgType === "SimpleCmdResponse") {
            gdataInfo.push({
                wsDataInfo: res,
            });
        }

        //collection = event.data;
         if (gconfig.length > 1) {
             gconfig.shift();
         }
        if (gstatus.length > 1) {
            gstatus.shift();
        }
        if (sounds.length > 1) {
            sounds.shift();
        }
        if (collection.length > 1) {
            collection.shift();
        } else {
            //MP: If this is a browser refresh, get lastscan from session storage
            
            
            if (sessionStorage.getItem("lastScan") !== null) {
                var sessData = sessionStorage.getItem("lastScan");
                sessData = JSON.parse(sessData);
                
                //if (gstatus[0].wsData.ScanCounter == sessData.StatusResponse.ScanCounter) {
                    sessData.StatusResponse.ScanCounter = gstatus[0].wsData.ScanCounter
                    collection.push({
                        wsData: sessData,
                    });
                //}

            }
            if (collection.length > 1) {
                collection.shift();
            }
        }
        if (gdataInfo.length > 1) {
            gdataInfo.shift();
        }
        if (settings.length > 1) {
            settings.shift();
        }
        //console.log(gconfig)
        //console.log(sounds)
        //console.log(gstatus)
        //console.log(settings)
        //console.log(collection)        
        //console.log(gdataInfo)
   
        
    });

    ws.onError(function (event) {
        console.log('connection Error', event);
    });

    ws.onClose(function (event) {
        console.log('connection closed', event);
        
    });

    ws.onOpen(function () {
        console.log('connection open');
        //ws.send('Connection Established');

    });


    return {
        gconfig: gconfig,
        gstatus: gstatus,
        sounds: sounds,
        settings: settings,
        collection: collection,        
        gdataInfo: gdataInfo,
        status: function () {
            return ws.readyState;
        },
        send: function (message) {
            if (angular.isString(message)) {
                ws.send(message);
            }
            else if (angular.isObject(message)) {
                ws.send(JSON.stringify(message));
            }
        },
        close: function () {
            ws.close();
        },
        reconnect: function () {
            ws.reconnect();
        },
        open: function () {
            ws.open();
        },
        getMsg: function () {
            return res;
        }


    };
})